<?php
// $Id: node.inc,v 1.1.2.2.2.2 2010/09/23 19:27:36 yhahn Exp $

/**
 * @file
 * Implementation of hook_diff() for node.module (body and title).
 */

/**
 * Implementation of hook_diff() for node.module (body and title).
 */
function user_user_diff($old_user, $new_user) {
  $result = array();
  $result['name'] = array(
    '#name' => t('User Name'),
    '#old' => array($old_user->name),
    '#new' => array($new_user->name),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );

  $result['email'] = array(
    '#name' => t('User Email'),
    '#old' => array($old_user->mail),
    '#new' => array($new_user->mail),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );

  $result['signature'] = array(
    '#name' => t('Signature'),
    '#old' => array($old_user->signature),
    '#new' => array($new_user->signature),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );

  $result['timezone'] = array(
    '#name' => t('Time Zone'),
    '#old' => array($old_user->timezone),
    '#new' => array($new_user->timezone),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );

  $result['language'] = array(
    '#name' => t('Language'),
    '#old' => array($old_user->language),
    '#new' => array($new_user->language),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );

  $result['theme'] = array(
    '#name' => t('Theme'),
    '#old' => array($old_user->theme),
    '#new' => array($new_user->theme),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );
  
  $old_user->picture->fid = isset($old_user->picture->fid) ? $old_user->picture->fid : NULL;
  $new_user->picture->fid = isset($new_user->picture->fid) ? $new_user->picture->fid : NULL;
  $result['picture'] = array(
    '#name' => t('Picture'),
    '#old' => array($old_user->picture->fid),
    '#new' => array($new_user->picture->fid),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );

  $result['status'] = array(
    '#name' => t('Status'),
    '#old' => array(($old_user->status) ? t('Active') : t('Blocked')),
    '#new' => array(($new_user->status) ? t('Active') : t('Blocked')),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );

  $result['ip'] = array(
    '#name' => t('Editor\'s IP'),
    '#old' => array($old_user->ip),
    '#new' => array($new_user->ip),
    '#weight' => -5,
    '#format' => array(
      'show_header' => FALSE,
    )
  );
  // @TODO: abstract this to work with all field types and/or split this
  // integration out to be more generic.
  $instances = field_info_instances('user', field_extract_bundle('user', 'user'));
  foreach ($instances as $instance) {
    $field_name = $instance['field_name'];
    $langcode = field_language('user', $new_user, $field_name);
    if (isset($new_user->{$field_name}[$langcode])) {
      foreach (array_keys($new_user->{$field_name}[$langcode]) as $delta) {
        if (isset($new_user->{$field_name}[$langcode][$delta]['value'])) {
          $view_old = $old_user->{$field_name}[$langcode][$delta]['value'];
          $view_new = $new_user->{$field_name}[$langcode][$delta]['value'];
          $result["{$field_name}_{$delta}"] = array(
            '#name' => t($instance['label']),
            '#old' => explode("\n", $view_old),
            '#new' => explode("\n", $view_new),
          );
        }
      }
    }
  }
  return $result;
}
